### dijkstra-kanten.py

# Das Programm benoetigt die ausgegliederten Funktionen:
from funktionen import first,second,last,rest,cons
# und
from prioritaetswarteschlange import *
# mit der Funktion fuege_alle_ein(<neue wegeliste>, vor, <priows>)
# Das Praedikat vor muss dafuer explizit passend definiert werden:
def vor(weg_1, weg_2):
    return first(weg_1) < first(weg_2)
# und
from kleiner_graph_kanten import *
# Verwendet wird davon hier das Dictionary gallenbacherGraph
# und die Zugriffsfunktion holeNachfolger, die zu einem Knoten
# alle Nachfogekanten holt.
# und
from wege import *
# Verwendet wird die Funktion alle-nachfolge-wege(<weg>, <graph>)

### =============== Entwurfsprinzip fuer Dijksta ===============
### Durch das Verwenden der Prioritaetswarteschlange ist gewaehrleistet,
### dass nur die kuerzesten Wege zu einem Knoten verwendet werden.
### Varianten:
# - Es wird nur der kuerzeste Weg zu einem Zielknoten gesucht.
# - Es werden alle kuerzesten Wege vom Startknoten aus gesucht.
### Entwurfsentscheidung: Variante 1 wird bearbeitet.

### ===== Dijksta =====
# Loesung mit passender Aufrufhuelle
def dijkstra(start_knoten, ziel_knoten, graph):
    return dijkstra_intern([start_knoten],     # besuchtliste
                           [],                 # kuerzeste_wege
                           fuege_alle_ein(     # Start-PrioWS
                               alle_nachfolge_wege(
                                   [0, start_knoten], # Start-'Weg'
                                   graph),
                               vor,
                               []),
                           ziel_knoten,
                           graph)

def dijkstra_intern(besucht, kuerzeste_wege, priows, ziel_knoten, graph):
    input((besucht, kuerzeste_wege, priows, ziel_knoten,'weiter?'))
    if len(priows)==0: return False
    elif last(first(priows)) == ziel_knoten:
        ##print(cons(first(priows), kuerzeste_wege))
        print("Loesung: ")
        print(first(priows))
        return first(priows)
    elif last(first(priows)) in besucht:
        return dijkstra_intern(besucht,
                               kuerzeste_wege,
                               rest(priows),
                               ziel_knoten,
                               graph)
    else: return dijkstra_intern(
        aktualisiere_besuchtliste(second(first(priows)), besucht),
        aktualisisere_kuerzeste_wege(besucht, first(priows), kuerzeste_wege),
        aktualisiere_priows(priows, graph),
        ziel_knoten,
        graph)


### ===== Hilfsfunktion aktualisiere-besuchtliste =====
def aktualisiere_besuchtliste(knoten, besucht):
    if knoten in besucht:
        return besucht
    else:
        return cons(knoten, besucht)

### ===== Hilfsfunktion aktualisiere-priows =====
# Zum ersten Weg aus der Prioritaetswarteschlange werden alle weiter
# fuehrenden wege des Graphen bestimmt
# und in den Rest der priows eingefuegt
def aktualisiere_priows(priows, graph):
    return fuege_alle_ein (alle_nachfolge_wege(first(priows),
                                               graph),
                           vor,
                           rest(priows))

### ===== Hilfsfunktion aktualisisere-kuerzeste_wege =====
# Nur neu erreichte Knoten ergeben einen kuerzesten Weg
def aktualisisere_kuerzeste_wege(besucht, weg, kuerzeste_wege):
    if second(weg) in besucht:
        return kuerzeste_wege
    else:
        return cons(weg, kuerzeste_wege)
    
#-----
# Tests dijkstra:
##print( dijkstra ('A', 'E', kleiner_graph_kanten) )
print( dijkstra ('A', 'F', kleiner_graph_kanten) )
